Update Travis.

This commit is contained in:
Markus F.X.J. Oberhumer
2016-09-26 00:01:41 +02:00
parent e6da9e8d1a
commit bd54499537
5 changed files with 64 additions and 28 deletions
+100
View File
@@ -0,0 +1,100 @@
#! /bin/bash
## vim:set ts=4 sw=4 et:
set -e; set -o pipefail
# Support for Travis CI -- https://travis-ci.org/upx/upx/builds
# Copyright (C) Markus Franz Xaver Johannes Oberhumer
source "$TRAVIS_BUILD_DIR/.github/travis_init.sh" || exit 1
echo "BUILD_METHOD='$BUILD_METHOD'"
echo "BUILD_DIR='$BUILD_DIR'"
echo "UPX_UCLDIR='$UPX_UCLDIR'"
echo "CC='$CC'"
echo "CXX='$CXX'"
echo "CPPFLAGS='$CPPFLAGS'"
echo "CFLAGS='$CFLAGS'"
echo "CXXFLAGS='$CXXFLAGS'"
echo "LDFLAGS='$LDFLAGS'"
echo "LIBS='$LIBS'"
echo "SCAN_BUILD='$SCAN_BUILD'"
#env | LC_ALL=C sort
echo "$CC --version"; $CC --version
echo "$CXX --version"; $CXX --version
# whitespace
if test "$TRAVIS_OS_NAME" = "linux"; then
echo "Checking source code for whitespace violations..."
find . \
-type d -name '.git' -prune -o \
-type d -name 'deps' -prune -o \
-type f -iname '*.bat' -prune -o \
-type f -iname '*.exe' -prune -o \
-type f -iname '*.pdf' -prune -o \
-type f -print0 | LC_ALL=C sort -z | \
xargs -0r perl -n -e '
if (m,[\r\x1a],) { print "ERROR: DOS EOL detected $ARGV: $_"; exit(1); }
if (m,([ \t]+)$,) {
# allow exactly two trailing spaces for GitHub flavoured Markdown in .md files
if ($1 ne " " || $ARGV !~ m,\.md$,) {
print "ERROR: trailing whitespace detected $ARGV: $_"; exit(1);
}
}
if (m,\t,) {
if ($ARGV =~ m,(^|/)\.gitmodules$,) { }
elsif ($ARGV =~ m,(^|/)make(file|vars),i) { }
elsif ($ARGV =~ m,/tmp/.*\.(disasm|dump)$,) { }
elsif ($ARGV =~ m,/src/stub/src/arch/.*\.S$,) { }
else { print "ERROR: hard TAB detected $ARGV: $_"; exit(1); }
}
' || exit 1
echo " Done."
fi # linux
set -x
#
# build UCL
#
cd /; cd "$UPX_UCLDIR" || exit 1
./configure --enable-static --disable-shared --disable-asm
make
#
# build UPX
#
cd /; cd "$BUILD_DIR" || exit 1
make="make -f $TRAVIS_BUILD_DIR/src/Makefile"
export EXTRA_CPPFLAGS="-DUCL_NO_ASM"
case $BUILD_METHOD in
debug | debug+* | *+debug | *+debug+*)
make="$make USE_DEBUG=1" ;;
esac
case $BUILD_METHOD in
sanitize | sanitize+* | *+sanitize | *+sanitize+*)
case $TRAVIS_OS_NAME-$CC in linux-gcc*) export EXTRA_LDFLAGS="-fuse-ld=gold" ;; esac
make="$make USE_SANITIZE=1" ;;
esac
case $BUILD_METHOD in
scan-build | scan-build+* | *+scan-build | *+scan-build+*)
make="$SCAN_BUILD $make" ;;
esac
case $BUILD_METHOD in
valgrind | valgrind+* | *+valgrind | *+valgrind+*)
export EXTRA_CPPFLAGS="$EXTRA_CPPFLAGS -DWITH_VALGRIND" ;;
esac
if test "$ALLOW_FAIL" = "1"; then
echo "ALLOW_FAIL=$ALLOW_FAIL"
set +e
fi
$make
ls -l upx.out
size upx.out
file upx.out
exit 0
+40
View File
@@ -0,0 +1,40 @@
## vim:set ts=4 sw=4 et:
# Support for Travis CI -- https://travis-ci.org/upx/upx/builds
# Copyright (C) Markus Franz Xaver Johannes Oberhumer
umask 022
cd /; cd "$TRAVIS_BUILD_DIR" || exit 1
if test "X$C" = "X"; then C=gcc; fi
BUILD_DIR="$TRAVIS_BUILD_DIR/build/$C"
mkdir -p "$BUILD_DIR"
if test "X$B" = "X"; then B=release; fi
BUILD_METHOD="$B"
CC=false CXX=false SCAN_BUILD=false
case $C in
clang | clang-m?? | clang-3.4-m?? | clang-[678][0-9][0-9]-m??)
# standard system compiler
CC="clang"; CXX="clang++" ;;
clang-[34].[0-9]-m??)
v=${C:6:3}; CC="clang-$v"; CXX="clang++-$v"; SCAN_BUILD="scan-build-$v" ;;
gcc | gcc-m?? | gcc-4.6-m??)
# standard system compiler
CC="gcc"; CXX="g++" ;;
gcc-[34].[0-9]-m??)
v=${C:4:3}; CC="gcc-$v"; CXX="g++-$v" ;;
gcc-[56]-m?? | gcc-[56].[0-9]-m??)
v=${C:4:1}; CC="gcc-$v"; CXX="g++-$v" ;;
esac
case $C in
*-m32) CC="$CC -m32"; CXX="$CXX -m32" ;;
*-m64) CC="$CC -m64"; CXX="$CXX -m64" ;;
esac
case $C in
clang* | gcc*) CC="$CC -std=gnu89" ;;
esac
export CC CXX
export UPX_UCLDIR="$TRAVIS_BUILD_DIR/deps/ucl-1.03"
+81
View File
@@ -0,0 +1,81 @@
#! /bin/bash
## vim:set ts=4 sw=4 et:
set -e; set -o pipefail
# Support for Travis CI -- https://travis-ci.org/upx/upx/builds
# Copyright (C) Markus Franz Xaver Johannes Oberhumer
source "$TRAVIS_BUILD_DIR/.github/travis_init.sh" || exit 1
set -x
cd /; cd "$BUILD_DIR" || exit 1
if test "$ALLOW_FAIL" = "1"; then
echo "ALLOW_FAIL=$ALLOW_FAIL"
set +e
if ! test -x $PWD/upx.out; then exit 0; fi
fi
if ! test -x $PWD/upx.out; then exit 1; fi
#
# very first version of the upx-testsuite
#
exit_code=0
checksum=sha256sum
if test "$TRAVIS_OS_NAME" = "osx"; then
checksum=true # TODO: travis-osx does not have md5sum and friends?
fi
upx="$PWD/upx.out"
case $BUILD_METHOD in
valgrind | valgrind+* | *+valgrind | *+valgrind+*)
upx="valgrind --leak-check=full --show-reachable=yes $upx" ;;
esac
upx_391=false
if test "$TRAVIS_OS_NAME" = "linux"; then
cp "$TRAVIS_BUILD_DIR/deps/upx-testsuite/files/packed/amd64-linux.elf/upx-3.91" upx391.out
upx_391="$PWD/upx391.out"
fi
$upx --help
cd /; cd "$TRAVIS_BUILD_DIR/deps/upx-testsuite/files" || exit 1
ls -l packed/*/upx-3.91*
$upx -l packed/*/upx-3.91*
$upx --file-info packed/*/upx-3.91*
$upx -t packed/*/upx-3.91*
for f in packed/*/upx-3.91*; do
echo "===== $f"
if test "$TRAVIS_OS_NAME" = "linux"; then
$upx_391 -d $f -o v391.tmp
$upx -d $f -o v392.tmp
$checksum v391.tmp v392.tmp
cmp -s v391.tmp v392.tmp
$upx_391 --lzma --fake-stub-version=3.92 --fake-stub-year=2016 v391.tmp -o v391_packed.tmp
$upx --lzma v392.tmp -o v392_packed.tmp
$checksum v391_packed.tmp v392_packed.tmp
else
$upx -d $f -o v392.tmp
$checksum v392.tmp
$upx --lzma v392.tmp -o v392_packed.tmp
$checksum v392_packed.tmp
fi
$upx -d v392_packed.tmp -o v392_decompressed.tmp
# after the first compression+decompression step the exe should be
# canonicalized so that further compression+decompression runs
# should yield identical results
if ! cmp -s v392.tmp v392_decompressed.tmp; then
# UPX 3.91 and 3.92 differ; run one more compression+decompression
ls -l v392.tmp v392_decompressed.tmp
echo "UPX-WARNING: $f"
$upx v392_decompressed.tmp -o v392_packed_2.tmp
$upx -d v392_packed_2.tmp -o v392_decompressed_2.tmp
if ! cmp -s v392_decompressed.tmp v392_decompressed_2.tmp; then
ls -l v392_decompressed.tmp v392_decompressed_2.tmp
echo "UPX-ERROR: $f"
exit_code=1
fi
fi
rm *.tmp
done
exit $exit_code